<template>
	<xn-form-container
		:title="formData.id ? '编辑学期表' : '增加学期表'"
		:width="700"
		:visible="visible"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="年度：" name="multiyear">
				<a-input v-model:value="formData.multiyear" placeholder="请输入年度" allow-clear />
			</a-form-item>
			<a-form-item label="季度：" name="quater">
				<a-input v-model:value="formData.quater" placeholder="请输入季度" allow-clear />
			</a-form-item>
			<a-form-item label="起始时间起：" name="startTime">
				<a-date-picker
					v-model:value="formData.startTime"
					value-format="YYYY-MM-DD HH:mm:ss"
					show-time
					placeholder="请选择起始时间起"
					style="width: 100%"
				/>
			</a-form-item>
			<a-form-item label="起始时间止：" name="endTime">
				<a-date-picker
					v-model:value="formData.endTime"
					value-format="YYYY-MM-DD HH:mm:ss"
					show-time
					placeholder="请选择起始时间止"
					style="width: 100%"
				/>
			</a-form-item>
			<a-form-item label="学期名称：" name="name">
				<a-input v-model:value="formData.name" placeholder="请输入学期名称" allow-clear />
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="semesterForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import semesterApi from '@/api/semesterApi'
	// 抽屉状态
	const visible = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)

	// 打开抽屉
	const onOpen = (record) => {
		visible.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		visible.value = false
	}
	// 默认要校验的
	const formRules = {}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value.validate().then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			semesterApi
				.semesterSubmitForm(formDataParam, formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
